###############################################################################
# SplitSplice.pl                                                              #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.1                                        #
# Released:       December 2001; Updated March 22, 2002                       #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2002 Xnull (www.xnull.com) - All Rights Reserved.        #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# =========================================================================== #
# Mod Name:    Split/Splice for SP1/1.1 - version 1.0 beta 2                  #
# Written by:  BHRA Webmaster (http://www.bhra.org.uk)                        #
###############################################################################

$SplitSplicemod = "Split/Splice v1.0 Beta 2";

$sstxt{'1'} = "Split Topic";
$sstxt{'2'} = "You are not allowed to split this topic...";
$sstxt{'3'} = "Split from";
$sstxt{'4'} = "Use the selection list to choose where to split this thread. The selected reply, and all subsequent replies will be moved to a new thread.";
$sstxt{'5'} = "Off topic replies have been moved to";
$sstxt{'6'} = "This Thread";
$sstxt{'7'} = "by";
$sstxt{'8'} = "There aren't any replies to split!";
$sstxt{'9'} = "You must select where to split the thread!";
$sstxt{'10'} = "Off Topic";
$sstxt{'11'} = "You cannot split topics containing only 1 post.";

$sstxt{'101'} = "Splice Topic";
$sstxt{'102'} = "You are not allowed to splice this topic...";
$sstxt{'103'} = "Splice to";
$sstxt{'104'} = "Use the selection list to choose which thread to move the contents of the current thread to.";
$sstxt{'105'} = "The contents of this thread have been moved";
$sstxt{'106'} = "HERE";
$sstxt{'107'} = "by";
$sstxt{'108'} = "Moved";
$sstxt{'109'} = "You must select a destination thread!";

$sstxt{'201'} = "Split/Splice Topic";
$sstxt{'202'} = "You are not allowed to split/splice this topic...";
$sstxt{'203'} = "Split posts";
$sstxt{'204'} = "-= All Posts =-";
$sstxt{'205'} = "Select which posts to move from the current thread. (Hold down the SHIFT or CTRL keys while clicking to select multiple posts.)";
$sstxt{'206'} = "'Moved to...' notice?";
$sstxt{'207'} = "Tick this if you want to add a link to the moved posts in the current thread.";
$sstxt{'208'} = "You must select at least one post to move!";
$sstxt{'209'} = "Reply";
$sstxt{'210'} = "Splice to";
$sstxt{'211'} = "-= New Thread =-";
$sstxt{'212'} = "Select which thread to move the contents of the current thread to.";
$sstxt{'213'} = "New Thread Subject";
$sstxt{'214'} = "If you are moving the selected posts to a new thread, you can enter the Subject of the new thread here. (Leave this box blank if you want to use the existing Subject from the first post selected.)";
$sstxt{'215'} = "Submit";
$sstxt{'216'} = "Reset";
$sstxt{'217'} = "You must select a destination thread!";
$sstxt{'218'} = "Are you sure you want to do this?";

###############################################################################

sub Split_Splice {

	if ($action eq "split") {
		$mode = 0;
		$postlist = qq~                    <option value="">\n~;
	} elsif ($action eq "splice") {
		$mode = 1;
		$threadlist = qq~                    <option value="">\n~;
	} elsif ($action eq "split_splice") { 
		if($ss_advanced ne "1") { &fatal_error("$sstxt{'202'}"); }
		$postlist = qq~                    <option value="all">$sstxt{'204'}\n~;
		$threadlist = qq~                    <option value="new">$sstxt{'211'}\n~;
		$mode = 2;
	}

	if ((!exists $moderators{$username}) && $settings[7] ne "Administrator" && $settings[7] ne "Global Moderator") { &fatal_error($txt{100 * $mode + 2}); }
	$yytitle = $sstxt{eval {100 * $mode + 1}};

	$curthread = $INFO{'thread'};
	&LoadCensorList;	# Load Censor List

	if($action ne "splice") { 
		fopen(FILE,"$datadir/$curthread.txt") || &fatal_error("$txt{'23'} $curthread.txt");
		@messages = <FILE>;
		fclose(FILE);
		if ($mode != 2 && $#messages == 0) {&fatal_error("$sstxt{'11'}");}
		for($counter = 0; $counter <= $#messages; $counter++) {
			if ($counter == 0 && $mode != 2) {next;}
			chomp $messages[$counter];
			($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $postmessage, $ns, $mlm, $mlmb) = split(/[\|]/, $messages[$counter]);
			foreach (@censored) {
				($tmpa,$tmpb) = @{$_};
				$postmessage =~ s~\Q$tmpa\E~$tmpb~gi;
			}
			if (length($postmessage) > 40) { $postmessage = substr($postmessage, 0, 40) . qq~ ...~; }
			$postlist .= qq~                    <option value="$counter">$sstxt{'209'} $counter: $postmessage\n~;
		}
	}

	if($action ne "split") { 
		fopen(FILE, "$boardsdir/$currentboard.txt") || &fatal_error("$txt{'23'} $currentboard.txt");
		@oldthreads = <FILE>;
		fclose(FILE);
		foreach $thread_data (@oldthreads) {
			chomp $thread_data;
			($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mattach) = split(/\|/,$thread_data);
			foreach (@censored) {
				($tmpa,$tmpb) = @{$_};
				$msub =~ s~\Q$tmpa\E~$tmpb~gi;
			}
			if (length($msub) > 40) { $msub = substr($msub, 0, 40) . qq~ ...~; }
			if ($mnum ne $curthread) { $threadlist .= qq~                    <option value="$mnum">$msub\n~; }
		}
	}

	if ($mode == 2) {$js = "this.ss_submit.disabled=true;this.ss_reset.disabled=true;";} else {$js = "this.ss_submit.disabled=true;";}

	$yymain .= qq~
<form action="$cgi;action=split_splice2;thread=$INFO{'thread'}" method="POST" name="split" onSubmit="$js"><br>
<input type="hidden" name="mode" value="$mode">
<table border="0" width="80%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td>
      <table cellpadding="4" cellspacing="1" border="0" width="100%">
        <tr>~;

	if ($action eq "split") { 

	$yymain .= qq~
          <td class="titlebg" bgcolor="$color{'titlebg'}"><img src="$imagesdir/admin_split.gif" align="absmiddle"> <font size="2" class="text1" color="$color{'titletext'}"><b>$sstxt{'1'}</b></font></td>
        </tr><tr>
          <td class="windowbg" bgcolor="$color{'windowbg'}" align="center"><br><font size="1">$sstxt{'4'}</font><br><br>
            <b>$sstxt{'3'}:</b> <select name="postid">
$postlist
            </select><input type="hidden" name="threadid" value="new"><input type="hidden" name="moved_to" value="1"><input type="hidden" name="new_subject" value=""><br><br>
          </td>
        </tr><tr>
          <td class="windowbg" bgcolor="$color{'windowbg'}" align="center"><font size="2"><input type="submit" name="ss_submit" value="$sstxt{'1'}"></font></td>
        </tr>~;

	} elsif ($action eq "splice") { 

	$yymain .= qq~
          <td class="titlebg" bgcolor="$color{'titlebg'}"><img src="$imagesdir/admin_splice.gif" align="absmiddle"> <font size="2" class="text1" color="$color{'titletext'}"><b>$sstxt{'101'}</b></font></td>
        </tr><tr>
          <td class="windowbg" bgcolor="$color{'windowbg'}" align="center"><br><font size="1">$sstxt{'104'}</font><br><br>
            <b>$sstxt{'103'}:</b> <select name="threadid">
$threadlist
            </select><input type="hidden" name="postid" value="all"><input type="hidden" name="moved_to" value="1"><input type="hidden" name="new_subject" value=""><br><br>
          </td>
        </tr><tr>
          <td class="windowbg" bgcolor="$color{'windowbg'}" align="center"><font size="2"><input type="submit" name="ss_submit" value="$sstxt{'101'}"></font></td>
        </tr>~;

	} elsif ($action eq "split_splice") { 

	$yymain .= qq~
          <td class="titlebg" bgcolor="$color{'titlebg'}"><img src="$imagesdir/admin_split_splice.gif" align="absmiddle"> <font size="2" class="text1" color="$color{'titletext'}"><b>$sstxt{'201'}</b></font></td>
        </tr><tr>
          <td class="windowbg" bgcolor="$color{'windowbg'}" align="center"><br>
            <table cellpadding="0" cellspacing="0" border="0" width="100%">
              <tr>
                <td valign="top" width="30%"><font size="2"><b>$sstxt{'203'}:</b></font></td>
                <td valign="top">
                  <select name="postid" multiple size="5" style="width:100%">
$postlist
                  </select>
                </td>
              </tr><tr>
                <td colspan="2"><font size="1">$sstxt{'205'}<br><br></font></td>
              </tr><tr>
                <td width="30%"><font size="2"><b>$sstxt{'206'}</b></font></td>
                <td><input type="checkbox" name="moved_to" value="1" checked></td>
              </tr><tr>
                <td colspan="2"><font size="1">$sstxt{'207'}<br><br></font></td>
              </tr>
            </table>
          </td>
        </tr><tr>
          <td class="windowbg" bgcolor="$color{'windowbg'}" align="center"><br>
            <table cellpadding="0" cellspacing="0" border="0" width="100%">
              <tr>
                <td width="30%"><font size="2"><b>$sstxt{'210'}:</b></font></td>
                <td>
                  <select name="threadid" style="width:100%">
$threadlist
                  </select>
                </td>
              </tr><tr>
                <td colspan="2"><font size="1">$sstxt{'212'}<br><br></font></td>
              </tr><tr>
                <td width="30%"><font size="2"><b>$sstxt{'213'}</b></font></td>
                <td><input type="text" name="new_subject" size="40" maxlength="50" style="width:100%"></td>
              </tr><tr>
                <td colspan="2"><font size="1">$sstxt{'214'}<br><br></font></td>
              </tr>
            </table>
          </td>
        </tr><tr>
          <td class="windowbg" bgcolor="$color{'windowbg'}" align="center"><font size="2"><input type="submit" name="ss_submit" value="$sstxt{'215'}"> &nbsp; <input type="reset" name="ss_reset" value="$sstxt{'216'}"></font></td>
        </tr>~;

	}

	$yymain .= qq~
      </table>
    </td>
  </tr>
</table>
</form>
<br>~;

	&template;
	exit;
}

###############################################################################

sub Split_Splice2 {
	$mode = $FORM{'mode'};	# 0 = Split, 1 = Splice, 2 = Split/Slice (Advanced Mode)
	if ((!exists $moderators{$username}) && $settings[7] ne "Administrator" && $settings[7] ne "Global Moderator") { &fatal_error($txt{100 * $mode + 2}); }

	$oldthreadid = $INFO{'thread'};
	$newthreadid = $FORM{'threadid'};
	if ($newthreadid eq "") { &fatal_error("$sstxt{'217'}"); }
	if ($FORM{'postid'} eq "") { &fatal_error("$sstxt{'208'}"); }
	if ($FORM{'postid'} =~ /all/) {$postid = "0";} else {$postid = $FORM{'postid'};}
	&fatal_error($txt{'77'}) unless(!$FORM{'new_subject'} || $FORM{'new_subject'} !~ m~\A[\s_.,]+\Z~);

	# Read existing threads.
	fopen(FILE, "$datadir/$oldthreadid.txt") || &fatal_error("$txt{'23'} $oldthreadid.txt");
	@old_messages = <FILE>;
	fclose(FILE);
	fopen(FILE, "$datadir/$oldthreadid.data") || &fatal_error("$txt{'23'} $oldthreadid.data");
	@old_thread_data = <FILE>;
	fclose(FILE);

	if ($mode != 2 || $FORM{'postid'} =~ /all/) { 
		for(my $i = $postid + 1; $i < @old_messages; $i++) { $postid .= ", $i"; }
	}

	# Find a valid random ID for new thread.
	if ($FORM{'threadid'} eq "new") { # Thread doesn't exist, find valid ID
		$new_thread = 1;
		$newthreadid = time;
		$i=0;
		if (-e "$datadir/$newthreadid.txt") {
			while (-e "$datadir/$newthreadid$i.txt") { ++$i; }
			$newthreadid = "$newthreadid$i";
		}
		@new_messages = "";
		@new_thread_data = "";
	} else { # Thread exists, load existing messages
		$new_thread = 0;
		fopen(FILE, "$datadir/$newthreadid.txt") || &fatal_error("$txt{'23'} $newthreadid.txt");
		@new_messages = <FILE>;
		fclose(FILE);
		fopen(FILE, "$datadir/$newthreadid.data") || &fatal_error("$txt{'23'} $newthreadid.data");
		@new_thread_data = <FILE>;
		fclose(FILE);
	}

#$yymain .= qq~Post id: $postid<br>Thread id: $newthreadid<br>Moved notice: $FORM{'moved_to'}<br>Date Order: $FORM{'date_order'}<br>New Subject: $FORM{'new_subject'}<br>~;
#&template;
#exit;

	# Update current thread.
	$tmp_threadcount = 0;
	$tmp_postcount = 0;
	@reply_ids = split(/\, /, $postid);
	foreach $id (@reply_ids) {
		push (@mobile_messages, $old_messages[$id]);
		$old_messages[$id] = "";
	}
	if ($FORM{'moved_to'}) { # leave "moved to..." notice
		($tmpsub, $tmpname, $tmpemail, $tmpdate, $tmpusername, $tmpicon, $tmpattach, $tmpip, $tmpmessage, $tmpns, $tmplm, $tmplmb, $tmpstuff) = split(/[\|]/, $mobile_messages[0], 13);
		if ($#mobile_messages == $#old_messages) {
			$moved_notice = qq~$tmpsub|$tmpname|$tmpemail|$tmpdate|$tmpusername|$tmpicon|0|$tmpip|$sstxt{'105'} \[link=$cgi;action=display;num=$newthreadid\]$sstxt{'106'}\[/link\] $sstxt{'107'} $settings[1].||$date|$username|\n~;
		} else {
			$moved_notice = qq~$tmpsub|$tmpname|$tmpemail|$tmpdate|$tmpusername|$tmpicon|0|$tmpip|$sstxt{'5'} \[link=$cgi;action=display;num=$newthreadid\]$sstxt{'6'}\[/link\] $sstxt{'7'} $settings[1].||$date|$username|\n~;
		}
		push (@old_messages, $moved_notice);
		$tmp_postcount++;
	} elsif ($#mobile_messages == $#old_messages) {# kill old thread
		opendir (MMD,$datadir);
		@contents = grep {/^$oldthreadid\./} readdir(DIR);
		closedir(MMD);
		foreach $file(@contents) {	
			unlink("$datadir/$file");
		}
		$tmp_threadcount--;
	}
	fopen(FILE, ">$datadir/$oldthreadid.txt") || &fatal_error("$txt{'23'} $oldthreadid.txt");
	print FILE @old_messages;
	fclose(FILE);
	if ($FORM{'moved_to'}) { 
		chomp $old_thread_data[0];
		@tmp_data = split(/\|/, $old_thread_data[0]);
		$tmp_data[1] = $username;
		$old_thread_data[0] = join("|", @tmp_data);
		if ($old_thread_data[1] ne "") {$old_thread_data[0] .= "\n";}
		fopen(FILE, "+>$datadir/$oldthreadid.data") || &fatal_error("$txt{'23'} $oldthreadid.data");
		print FILE @old_thread_data;
		fclose(FILE);
	}

	# Save new thread.
	if ($new_thread) {$tmp_threadcount++;}
	if ($FORM{'new_subject'} && $new_thread) {
		&ToHTML($FORM{'new_subject'});
		($tmpsub, $stuff) = split(/[\|]/, $mobile_messages[0], 2);
		$mobile_messages[0] = qq~$FORM{'new_subject'}|$stuff~;;
		
	}
	push (@new_messages, @mobile_messages);
	fopen(FILE, ">$datadir/$newthreadid.txt") || &fatal_error("$txt{'23'} $newthreadid.txt");
	print FILE @new_messages;
	fclose(FILE);
	($dummy, $dummy, $dummy, $newlastposttime, $newlastposter, $dummy) = split(/[\|]/, $new_messages[$#new_messages]);
	chomp $new_thread_data[0];
	@tmp_data = split(/\|/, $new_thread_data[0]);
	$tmp_data[1] = $newlastposter;
	$new_thread_data[0] = join("|", @tmp_data);
	if ($new_thread_data[1] ne "") {$new_thread_data[0] .= "\n";}
	fopen(FILE, "+>$datadir/$newthreadid.data") || &fatal_error("$txt{'23'} $newthreadid.txt");
	print FILE @new_thread_data;
	fclose(FILE);

	# Update message index.
	fopen(FILE2, "$boardsdir/$currentboard.txt") || &fatal_error("$txt{'23'} $currentboard.txt");
	@threads = <FILE2>;
	fclose(FILE2);

	for(my $i = 0; $i < @threads; $i++) {
		if( $threads[$i] =~ m~\A$newthreadid\|~o ) { $NewThreadLine = $threads[$i]; $NewThreadPosition = $i;}
		if( $threads[$i] =~ m~\A$oldthreadid\|~o ) { $OldThreadLine = $threads[$i]; $OldThreadPosition = $i;}
	}

	@tmp_messages = split(/\n/, join('', @old_messages));
	chomp $OldThreadLine;
	($oldsub, $oldname, $oldemail, $dummy, $oldusername, $oldicon, $oldattach, $oldip, $oldmessage, $oldns, $oldlm, $oldlmb, $dummy) = split(/[\|]/, $tmp_messages[0], 13);
	($dummy, $dummy, $dummy, $olddate, $dummy) = split(/[\|]/, $tmp_messages[$#tmp_messages]);
	($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate, $mstuff) = split(/\|/, $OldThreadLine, 10);
	if ($#mobile_messages == $#old_messages && !$FORM{'moved_to'}) {
		$OldThreadLine = qq~~;
	} elsif ($#mobile_messages == $#old_messages && $FORM{'moved_to'}) {
		$OldThreadLine = qq~$oldthreadid|$sstxt{'108'}: $oldsub|$oldname|$oldemail|$olddate|0|$oldusername|$oldicon|1|$mstuff\n~;
	} else {
		$OldThreadLine = qq~$oldthreadid|$oldsub|$oldname|$oldemail|$olddate|$#tmp_messages|$oldusername|$oldicon|$mstate|$mstuff\n~;
	}

	@tmp_messages = split(/\n/, join('', @new_messages));
	chomp $NewThreadLine;
	($newsub, $newname, $newemail, $dummy, $newusername, $newicon, $newattach, $newip, $newmessage, $newns, $newlm, $newlmb, $dummy) = split(/[\|]/, $tmp_messages[0], 13);
	($dummy, $dummy, $dummy, $newdate, $dummy) = split(/[\|]/, $tmp_messages[$#tmp_messages]);
	($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate, $mstuff) = split(/\|/, $NewThreadLine, 10);
	$NewThreadLine = qq~$newthreadid|$newsub|$newname|$newemail|$newdate|$#tmp_messages|$newusername|$newicon|$mstate|$mstuff\n~;

	fopen(FILE2, "+<$boardsdir/$currentboard.txt", 1) || &fatal_error("211 $txt{'106'}: $txt{'23'} $currentboard.txt");
		seek FILE2, 0, 0;
		my @buffer = <FILE2>;
		truncate FILE2, 0;
		for ($a = 0; $a < @buffer; $a++) {
			if ( $buffer[$a] =~ m~\A$newthreadid\|~o ) { $buffer[$a] = "";}
			if ( $buffer[$a] =~ m~\A$oldthreadid\|~o ) { $buffer[$a] = "$OldThreadLine";}
		}
		seek FILE2, 0, 0;
		print FILE2 qq~$NewThreadLine~;
		print FILE2 @buffer;
	fclose(FILE2);

	# Update totals for this board.
	fopen(FILEBOARDGET, "$boardsdir/$currentboard.ttl");
	$tmpa = <FILEBOARDGET>;
	fclose(FILEBOARDGET);
	chomp $tmpa;
	( $threadcount, $messagecount, $lastposttime, $lastposter, $lastthreadid ) = split( /\|/, $tmpa, 5 );
	$threadcount = $threadcount + $tmp_threadcount;
	$messagecount = $messagecount + $tmp_postcount;

	if ($NewThreadPosition == 0) {
		$lastposttime = $newlastposttime;
		$lastposter = $newlastposter;
		$tmpthreadid = $newthreadid;
	} elsif ($OldThreadPosition == 0) {
		$lastposttime = $tmpdate;
		$lastposter = $tmpusername;
		$tmpthreadid = $oldthreadid;
	} else {
		$tmpthreadid = $lastthreadid;
	}
	fopen(FILE, "+>$boardsdir/$currentboard.poster");
	print FILE $lastposter;
	fclose(FILE);

	$tmpa = qq~$threadcount|$messagecount|$lastposttime|$lastposter~;
	if ($lastthreadid) { $tmpa .= qq~|$tmpthreadid~; }
	fopen(FILEBOARDSET, "+>$boardsdir/$currentboard.ttl");
	print FILEBOARDSET $tmpa;
	fclose(FILEBOARDSET);

	# Update file attachments.
	fopen(AMV, "$vardir/attachments.txt");
	my @attachments = <AMV>;
	fclose(AMV);
	fopen(AMV, ">$vardir/attachments.txt");
	foreach $row(@attachments) {
		chomp $row;
		my ($amthreadid, $amreplies, $amthreadsub, $amposter, $amcurrentboard, $amkb, $amdate, $amfn) = split(/\|/,$row);
		if($amthreadid eq $oldthreadid) {
			$tmpreplies = $amreplies;
			$tmpthreadid = $amthreadid;
			for(my $i = 0; $i < @reply_ids; $i++) {
				if ($reply_ids[$i] == $amreplies) {$tmpreplies = $#tmp_messages - $#mobile_messages + $i; $tmpthreadid = $newthreadid; last;}
				if ($reply_ids[$i] < $amreplies) {$tmpreplies--;}				
			}
			print AMV qq~$tmpthreadid|$tmpreplies|$amthreadsub|$amposter|$amcurrentboard|$amkb|$amdate|$amfn\n~;
		} else {
			print AMV qq~$amthreadid|$amreplies|$amthreadsub|$amposter|$amcurrentboard|$amkb|$amdate|$amfn\n~;
		}
	}
	fclose(AMV);

	$yySetLocation = qq~$cgi;action=display;num=$newthreadid~;
	&redirectexit;
}

1;